Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp	(revision 503)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp	(revision 508)
@@ -1140,10 +1140,10 @@
 		 "0.1");
 
-  RegisterOption("Sampling.totalSamples",
+  RegisterOption("SamplingPreprocessor.totalSamples",
 		 optInt,
 		 "total_samples=",
 		 "1000000");
 
-  RegisterOption("Sampling.samplesPerPass",
+  RegisterOption("SamplingPreprocessor.samplesPerPass",
 		 optInt,
 		 "samples_per_pass=",
@@ -1191,5 +1191,5 @@
 	  optBool,
 	  "-vss_use_viewspace_box=",
-	  "true");
+	  "false");
    
 
@@ -1199,288 +1199,293 @@
 
 
-  RegisterOption("ViewCells.type",
-		 optString,
-		 "view_cells_type",
-		 "bspTree");
-
-  RegisterOption("ViewCells.PostProcess.samples",
-				 optInt,
-				 "view_cells_postprocess_samples=",
-				 "200000");
-  
-  RegisterOption("ViewCells.Visualization.samples",
-				 optInt,
-				 "view_cells_visualization_samples=",
-				 "20000");
-  
-   RegisterOption("ViewCells.loadFromFile",
-				  optBool,
-				  "view_cells_load_from_file",
-				  "false");
-   
-  RegisterOption("ViewCells.maxViewCells",
-		 optInt,
-		 "view_cells_max_view_cells=",
-		 "0");
-
-  
-  RegisterOption("ViewCells.maxPvs",
-				 optInt,
-				 "view_cells_max_pvs=",
-				 "300");
- 
-  RegisterOption("ViewCells.filename",
-		 optString,
-		 "view_cells_filename=",
-		 "atlanta_viewcells_large.x3d");
-
-   RegisterOption("ViewCells.height",
-		 optFloat,
-		 "view_cells_height=",
-		 "5.0");
-
-   RegisterOption("ViewCells.Visualization.colorCode",
+	RegisterOption("ViewCells.type",
+			optString,
+			"view_cells_type",
+			"bspTree");
+
+	RegisterOption("ViewCells.PostProcess.samples",
+					optInt,
+					"view_cells_postprocess_samples=",
+					"200000");
+
+	RegisterOption("ViewCells.Visualization.samples",
+					optInt,
+					"view_cells_visualization_samples=",
+					"20000");
+
+	RegisterOption("ViewCells.loadFromFile",
+					optBool,
+					"view_cells_load_from_file",
+					"false");
+
+	RegisterOption("ViewCells.exportToFile",
+					optBool,
+					"view_cells_export_to_file",
+					"false");
+
+	RegisterOption("ViewCells.maxViewCells",
+			optInt,
+			"view_cells_max_view_cells=",
+			"0");
+
+	RegisterOption("ViewCells.maxPvs",
+					optInt,
+					"view_cells_max_pvs=",
+					"300");
+
+	RegisterOption("ViewCells.filename",
+			optString,
+			"view_cells_filename=",
+			"atlanta_viewcells_large.x3d");
+
+	RegisterOption("ViewCells.height",
+			optFloat,
+			"view_cells_height=",
+			"5.0");
+
+	RegisterOption("ViewCells.Visualization.colorCode",
 		optString,
 		"-view_cells_visualization.color_code",
 		"PVS");
 
-   RegisterOption("ViewCells.Visualization.exportRays",
-	  optBool,
-	  "-bsp_visualization.export_rays",
-	  "false");
-   
-   RegisterOption("ViewCells.Visualization.exportGeometry",
-	  optBool,
-	  "-bsp_visualization.export_geometry",
-	  "false");
-
-  /************************************************************************************/
-  /*                         Render simulation related options                        */
-  /************************************************************************************/
-
-
-  RegisterOption("Simulation.objRenderCost",
-		 optFloat,
-		 "simulation_obj_render_cost",
-		 "1.0");
-
-  RegisterOption("Simulation.vcOverhead",
-		 optFloat,
-		 "simulation_vc_overhead",
-		 "0.05");
-
-  RegisterOption("Simulation.moveSpeed",
-		 optFloat,
-		 "simulation_moveSpeed",
-		 "1.0");
-
-
-
-
-  /************************************************************************************/
-  /*                         Bsp tree related options                                 */
-  /************************************************************************************/
-
-
-  RegisterOption("BspTree.Construction.input",
-	  optString,
-	  "bsp_construction_input=",
-	  "fromViewCells");
-  
-  RegisterOption("BspTree.Construction.samples",
-	  optInt,
-	  "bsp_construction_samples=",
-	  "100000");
-
-  RegisterOption("BspTree.Construction.epsilon",
-	  optFloat,
-	  "bsp_construction_side_tolerance=",
-	  "0.002");
-
-  RegisterOption("BspTree.Termination.minPolygons",
-		 optInt,
-		 "bsp_term_min_polygons=",
-		 "5");
-
-  RegisterOption("BspTree.Termination.minPvs",
-		 optInt,
-		 "bsp_term_min_pvs=",
-		 "20");
-
-  RegisterOption("BspTree.Termination.minArea",
-		 optFloat,
-		 "bsp_term_min_area=",
-		 "0.001");
-  
-  RegisterOption("BspTree.Termination.maxRayContribution",
-		 optFloat,
-		 "bsp_term_ray_contribution=",
-		 "0.005");
-
-  RegisterOption("BspTree.Termination.minAccRayLenght",
-		 optFloat,
-		 "bsp_term_min_acc_ray_length=",
-		 "50");
-
-   RegisterOption("BspTree.Termination.minRays",
-		 optInt,
-		 "bsp_term_min_rays=",
-		 "-1");
-
-   RegisterOption("BspTree.Termination.ct_div_ci",
-		 optFloat,
-		 "bsp_term_ct_div_ci=",
-		 "0.0");
-  
-  RegisterOption("BspTree.Termination.maxDepth",
-		 optInt,
-		 "bsp_term_max_depth=",
-		 "100");
-
-  RegisterOption("BspTree.Termination.maxCostRatio",
-		 optFloat,
-		 "bsp_term_axis_aligned_max_cost_ratio=",
-		 "1.5");
-
-  RegisterOption("BspTree.Termination.AxisAligned.ct_div_ci",
-		 optFloat,
-		 "bsp_term_axis_aligned_ct_div_ci=",
-		 "0.5");
-
-  RegisterOption("BspTree.AxisAligned.splitBorder",
-		 optFloat,
-		 "bsp__axis_aligned_split_border=",
-		 "0.1");
-
-  RegisterOption("BspTree.Termination.AxisAligned.minPolys",
-		 optInt,
-		 "bsp_term_axis_aligned_max_polygons=",
-		 "50");
-
-   RegisterOption("BspTree.Termination.AxisAligned.minObjects",
-		 optInt,
-		 "bsp_term_min_objects=",
-		 "3");
-
-  RegisterOption("BspTree.Termination.AxisAligned.minRays",
-		 optInt,
-		 "bsp_term_axis_aligned_min_rays=",
-		 "-1");
-
-  RegisterOption("BspTree.splitPlaneStrategy",
-		 optString,
-		 "bsp_split_method=",
-		 "leastSplits");
-
-  RegisterOption("BspTree.maxPolyCandidates",
-	  optInt,
-	  "bsp_max_poly_candidates=",
-	  "20");
-
-  RegisterOption("BspTree.maxRayCandidates",
-	  optInt,
-	  "bsp_max_plane_candidates=",
-	  "20");
-
-  RegisterOption("BspTree.maxTests",
-	  optInt,
-	  "bsp_max_tests=",
-	  "5000");
-
-  RegisterOption("BspTree.Visualization.exportSplits",
-	  optBool,
-	  "bsp_visualization.export_splits",
-	  "false");
-
-  RegisterOption("BspTree.Factor.verticalSplits", optFloat, "bsp_factor_vertical=", "1.0");
-   RegisterOption("BspTree.Factor.largestPolyArea", optFloat, "bsp_factor_largest_poly=", "1.0");
-   RegisterOption("BspTree.Factor.blockedRays", optFloat, "bsp_factor_blocked=", "1.0");
-   RegisterOption("BspTree.Factor.leastSplits", optFloat, "bsp_factor_least_splits=", "1.0");
-   RegisterOption("BspTree.Factor.balancedPolys", optFloat, "bsp_factor_balanced_polys=", "1.0");
-   RegisterOption("BspTree.Factor.balancedViewCells", optFloat, "bsp_factor_balanced_view_cells=", "1.0");
-   RegisterOption("BspTree.Factor.leastRaySplits", optFloat, "bsp_factor_least_ray_splits=", "1.0");
-   RegisterOption("BspTree.Factor.balancedRays", optFloat, "bsp_factor_balanced_rays=", "1.0");
-   RegisterOption("BspTree.Factor.pvs", optFloat, "bsp_factor_pvs=", "1.0");
-
-   /************************************************************************************/
-   /*                         Preprocessor related options                             */
-   /************************************************************************************/
-
-   RegisterOption("Preprocessor.type",
-				 optString,
-				 "preprocessor=",
-				 "sampling");
-
-   RegisterOption("Preprocessor.samplesFilename",
-				  optString,
-				  "-preprocessor_samples_filename=",
-				  "rays.out");
-
-  RegisterOption("Preprocessor.useGlRenderer",
-				 optBool,
-				 "useGlRenderer",
-				 "false");
-  
-  /**************************************************************************************/
-  /*                  View space partition KD tree related options                      */
-  /**************************************************************************************/
-
-   RegisterOption("VspKdTree.Construction.samples",
-				  optInt,
-				  "vsp_kd_construction_samples=",
-				  "100000");
-
-   RegisterOption("VspKdTree.Termination.maxDepth", 
-	   optInt, 
-	   "vsp_term_maxdepth=", "30");
-
-   RegisterOption("VspKdTree.Termination.minPvs", 
-	   optInt, 
-	   "vsp_minpvs=", 
-	   "1");
-
-   RegisterOption("VspKdTree.Termination.minRays", 
-	   optInt, 
-	   "vsp_term_minrays=", 
-	   "10");
-
-   RegisterOption("VspKdTree.Termination.minSize", 
-	   optFloat, 
-	   "vsp_term_minsize=", 
-	   "0.001");
-
-   RegisterOption("VspKdTree.Termination.maxCostRatio", 
-	   optFloat, 
-	   "vsp_term_maxcost=",
-	   "0.95");
-
-   RegisterOption("VspKdTree.Termination.maxRayContribution", 
-	   optFloat, 
-	   "vsp_term_max_ray_contrib=", 
-	   "0.5");
-
-   RegisterOption("VspKdTree.epsilon", 
-	   optFloat, 
-	   "kd_eps=", 
-	   "1e-6");
-
-   RegisterOption("VspKdTree.ct_div_ci", 
-	   optFloat, 
-	   "vsp_ctdivci=", "1.0");
-   
-   RegisterOption("VspKdTree.splitType", 
-	   optString, 
-	   "split=", 
-	   "queries");
-
-  RegisterOption("VspKdTree.splitAxis", 
-	   optString, 
-	   "split=", 
-	   "drivingAxis");
-
-  RegisterOption("VspKdTree.splitUseOnlyDrivingAxis", 
-	  optBool, 
-	  "vsp_kd_splitdriving=", 
-	  "false");
+	RegisterOption("ViewCells.Visualization.exportRays",
+		optBool,
+		"-bsp_visualization.export_rays",
+		"false");
+
+	RegisterOption("ViewCells.Visualization.exportGeometry",
+		optBool,
+		"-bsp_visualization.export_geometry",
+		"false");
+
+
+	/************************************************************************************/
+	/*                         Render simulation related options                        */
+	/************************************************************************************/
+
+
+	RegisterOption("Simulation.objRenderCost",
+			optFloat,
+			"simulation_obj_render_cost",
+			"1.0");
+
+	RegisterOption("Simulation.vcOverhead",
+			optFloat,
+			"simulation_vc_overhead",
+			"0.05");
+
+	RegisterOption("Simulation.moveSpeed",
+			optFloat,
+			"simulation_moveSpeed",
+			"1.0");
+
+
+
+
+	/************************************************************************************/
+	/*                         Bsp tree related options                                 */
+	/************************************************************************************/
+
+
+	RegisterOption("BspTree.Construction.input",
+		optString,
+		"bsp_construction_input=",
+		"fromViewCells");
+
+	RegisterOption("BspTree.Construction.samples",
+		optInt,
+		"bsp_construction_samples=",
+		"100000");
+
+	RegisterOption("BspTree.Construction.epsilon",
+		optFloat,
+		"bsp_construction_side_tolerance=",
+		"0.002");
+
+	RegisterOption("BspTree.Termination.minPolygons",
+			optInt,
+			"bsp_term_min_polygons=",
+			"5");
+
+	RegisterOption("BspTree.Termination.minPvs",
+			optInt,
+			"bsp_term_min_pvs=",
+			"20");
+
+	RegisterOption("BspTree.Termination.minArea",
+			optFloat,
+			"bsp_term_min_area=",
+			"0.001");
+
+	RegisterOption("BspTree.Termination.maxRayContribution",
+			optFloat,
+			"bsp_term_ray_contribution=",
+			"0.005");
+
+	RegisterOption("BspTree.Termination.minAccRayLenght",
+			optFloat,
+			"bsp_term_min_acc_ray_length=",
+			"50");
+
+	RegisterOption("BspTree.Termination.minRays",
+			optInt,
+			"bsp_term_min_rays=",
+			"-1");
+
+	RegisterOption("BspTree.Termination.ct_div_ci",
+			optFloat,
+			"bsp_term_ct_div_ci=",
+			"0.0");
+
+	RegisterOption("BspTree.Termination.maxDepth",
+			optInt,
+			"bsp_term_max_depth=",
+			"100");
+
+	RegisterOption("BspTree.Termination.maxCostRatio",
+			optFloat,
+			"bsp_term_axis_aligned_max_cost_ratio=",
+			"1.5");
+
+	RegisterOption("BspTree.Termination.AxisAligned.ct_div_ci",
+			optFloat,
+			"bsp_term_axis_aligned_ct_div_ci=",
+			"0.5");
+
+	RegisterOption("BspTree.AxisAligned.splitBorder",
+			optFloat,
+			"bsp__axis_aligned_split_border=",
+			"0.1");
+
+	RegisterOption("BspTree.Termination.AxisAligned.minPolys",
+			optInt,
+			"bsp_term_axis_aligned_max_polygons=",
+			"50");
+
+	RegisterOption("BspTree.Termination.AxisAligned.minObjects",
+			optInt,
+			"bsp_term_min_objects=",
+			"3");
+
+	RegisterOption("BspTree.Termination.AxisAligned.minRays",
+			optInt,
+			"bsp_term_axis_aligned_min_rays=",
+			"-1");
+
+	RegisterOption("BspTree.splitPlaneStrategy",
+			optString,
+			"bsp_split_method=",
+			"leastSplits");
+
+	RegisterOption("BspTree.maxPolyCandidates",
+		optInt,
+		"bsp_max_poly_candidates=",
+		"20");
+
+	RegisterOption("BspTree.maxRayCandidates",
+		optInt,
+		"bsp_max_plane_candidates=",
+		"20");
+
+	RegisterOption("BspTree.maxTests",
+		optInt,
+		"bsp_max_tests=",
+		"5000");
+
+	RegisterOption("BspTree.Visualization.exportSplits",
+		optBool,
+		"bsp_visualization.export_splits",
+		"false");
+
+	RegisterOption("BspTree.Factor.verticalSplits", optFloat, "bsp_factor_vertical=", "1.0");
+	RegisterOption("BspTree.Factor.largestPolyArea", optFloat, "bsp_factor_largest_poly=", "1.0");
+	RegisterOption("BspTree.Factor.blockedRays", optFloat, "bsp_factor_blocked=", "1.0");
+	RegisterOption("BspTree.Factor.leastSplits", optFloat, "bsp_factor_least_splits=", "1.0");
+	RegisterOption("BspTree.Factor.balancedPolys", optFloat, "bsp_factor_balanced_polys=", "1.0");
+	RegisterOption("BspTree.Factor.balancedViewCells", optFloat, "bsp_factor_balanced_view_cells=", "1.0");
+	RegisterOption("BspTree.Factor.leastRaySplits", optFloat, "bsp_factor_least_ray_splits=", "1.0");
+	RegisterOption("BspTree.Factor.balancedRays", optFloat, "bsp_factor_balanced_rays=", "1.0");
+	RegisterOption("BspTree.Factor.pvs", optFloat, "bsp_factor_pvs=", "1.0");
+
+	/************************************************************************************/
+	/*                         Preprocessor related options                             */
+	/************************************************************************************/
+
+	RegisterOption("Preprocessor.type",
+					optString,
+					"preprocessor=",
+					"sampling");
+
+	RegisterOption("Preprocessor.samplesFilename",
+					optString,
+					"-preprocessor_samples_filename=",
+					"rays.out");
+
+	RegisterOption("Preprocessor.useGlRenderer",
+					optBool,
+					"useGlRenderer",
+					"false");
+
+	/**************************************************************************************/
+	/*                  View space partition KD tree related options                      */
+	/**************************************************************************************/
+
+	RegisterOption("VspKdTree.Construction.samples",
+					optInt,
+					"vsp_kd_construction_samples=",
+					"100000");
+
+	RegisterOption("VspKdTree.Termination.maxDepth", 
+		optInt, 
+		"vsp_term_maxdepth=", "30");
+
+	RegisterOption("VspKdTree.Termination.minPvs", 
+		optInt, 
+		"vsp_minpvs=", 
+		"1");
+
+	RegisterOption("VspKdTree.Termination.minRays", 
+		optInt, 
+		"vsp_term_minrays=", 
+		"10");
+
+	RegisterOption("VspKdTree.Termination.minSize", 
+		optFloat, 
+		"vsp_term_minsize=", 
+		"0.001");
+
+	RegisterOption("VspKdTree.Termination.maxCostRatio", 
+		optFloat, 
+		"vsp_term_maxcost=",
+		"0.95");
+
+	RegisterOption("VspKdTree.Termination.maxRayContribution", 
+		optFloat, 
+		"vsp_term_max_ray_contrib=", 
+		"0.5");
+
+	RegisterOption("VspKdTree.epsilon", 
+		optFloat, 
+		"kd_eps=", 
+		"1e-6");
+
+	RegisterOption("VspKdTree.ct_div_ci", 
+		optFloat, 
+		"vsp_ctdivci=", "1.0");
+
+	RegisterOption("VspKdTree.splitType", 
+		optString, 
+		"split=", 
+		"queries");
+
+	RegisterOption("VspKdTree.splitAxis", 
+		optString, 
+		"split=", 
+		"drivingAxis");
+
+	RegisterOption("VspKdTree.splitUseOnlyDrivingAxis", 
+		optBool, 
+		"vsp_kd_splitdriving=", 
+		"false");
 
 	RegisterOption("VspKdTree.numberOfEndPointDomains", 
@@ -1535,7 +1540,7 @@
 
 	RegisterOption("VspKdTree.Termination.missTolerance",
-		 optInt,
-		 "-vsp_kd_term_miss_tolerance=",
-		 "4");
+			optInt,
+			"-vsp_kd_term_miss_tolerance=",
+			"4");
 
 	/************************************************************************************/
@@ -1582,33 +1587,33 @@
 
 	RegisterOption("RssPreprocessor.vssSamples",
-				   optInt,
-				   "rss_vss_samples=",
-				   "1000000");
-	
+					optInt,
+					"rss_vss_samples=",
+					"1000000");
+
 	RegisterOption("RssPreprocessor.vssSamplesPerPass",
-				   optInt,
-				   "rss_vss_samples_per_pass=",
-				   "1000");
-	
+					optInt,
+					"rss_vss_samples_per_pass=",
+					"1000");
+
 	RegisterOption("RssPreprocessor.samplesPerPass",
-				   optInt,
-				   "rss_samples_per_pass=",
-				   "100000");
-	
+					optInt,
+					"rss_samples_per_pass=",
+					"100000");
+
 	RegisterOption("RssPreprocessor.useImportanceSampling",
-				   optBool,
-				   "rss_use_importance",
-				   "true");
-	
+					optBool,
+					"rss_use_importance",
+					"true");
+
 	RegisterOption("RssPreprocessor.objectBasedSampling",
-				   optBool,
-				   "rss_object_based_sampling",
-				   "true");
-	
+					optBool,
+					"rss_object_based_sampling",
+					"true");
+
 	RegisterOption("RssPreprocessor.directionalSampling",
-				   optBool,
-				   "rss_directional_sampling",
-				   "false");
-	
+					optBool,
+					"rss_directional_sampling",
+					"false");
+
 	RegisterOption("RssTree.maxDepth", optInt, "kd_depth=", "12");
 	RegisterOption("RssTree.minPvs", optInt, "kd_minpvs=", "1");
@@ -1616,5 +1621,5 @@
 	RegisterOption("RssTree.maxCostRatio", optFloat, "maxcost=", "0.95");
 	RegisterOption("RssTree.maxRayContribution", optFloat, "maxraycontrib=", "0.5");
-	
+
 	RegisterOption("RssTree.epsilon", optFloat, "kd_eps=", "1e-6");
 	RegisterOption("RssTree.ct_div_ci", optFloat, "kd_ctdivci=", "1.0");
@@ -1622,14 +1627,14 @@
 	RegisterOption("RssTree.splitType", optString, "split=", "queries");
 	RegisterOption("RssTree.splitUseOnlyDrivingAxis", optBool, "splitdriving=", "false");
-	
+
 	RegisterOption("RssTree.numberOfEndPointDomains", optInt, "endpoints=", "10000");
-	
+
 	RegisterOption("RssTree.minSize", optFloat, "minsize=", "0.001");
-	
+
 	RegisterOption("RssTree.maxTotalMemory", optFloat, "mem=", "60.0");
 	RegisterOption("RssTree.maxStaticMemory", optFloat, "statmem=", "8.0");
-	
+
 	RegisterOption("RssTree.queryType", optString, "qtype=", "static");
-	
+
 	RegisterOption("RssTree.queryPosWeight", optFloat, "qposweight=", "0.0");
 	RegisterOption("RssTree.useRefDirSplits", optBool, "refdir", "false");
@@ -1638,10 +1643,10 @@
 	RegisterOption("RssTree.accessTimeThreshold", optInt, "accesstime=", "1000");
 	RegisterOption("RssTree.minCollapseDepth", optInt, "colldepth=", "4");
-	
+
 	RegisterOption("RssTree.interleaveDirSplits", optBool, "interleavedirsplits", "true");
 	RegisterOption("RssTree.dirSplitDepth", optInt, "dirsplidepth=", "10");
 	RegisterOption("RssTree.importanceBasedCost", optBool, "importance_based_cost", "true");
 	RegisterOption("RssTree.maxRays", optInt, "rss_max_rays=", "2000000");
-	
+
 	RegisterOption("RssPreprocessor.Export.pvs", optBool, "rss_export_pvs", "false");
 	RegisterOption("RssPreprocessor.Export.rssTree", optBool, "rss_export_rss_tree", "false");
@@ -1650,62 +1655,65 @@
 	RegisterOption("RssPreprocessor.useViewcells", optBool, "rss_use_viewcells", "false");
 	RegisterOption("RssPreprocessor.updateSubdivision", optBool, "rss_update_subdivision", "false");
-	
-	
-  /************************************************************************************/
-  /*               View space partition BSP tree related options                      */
-  /************************************************************************************/
+
+
+/************************************************************************************/
+/*               View space partition BSP tree related options                      */
+/************************************************************************************/
 
 
 	RegisterOption("RssPreprocessor.loadInitialSamples",
-				   optBool,
-				   "vss_load_loadInitialSamples=",
-				   "false");
+					optBool,
+					"vss_load_loadInitialSamples=",
+					"false");
 
 	RegisterOption("RssPreprocessor.storeInitialSamples",
-				   optBool,
-				   "vss_store_storeInitialSamples=",
-				   "false");
-
-	/************************************************************************************/
-	/*               View space partition BSP tree related options                      */
-	/************************************************************************************/
+					optBool,
+					"vss_store_storeInitialSamples=",
+					"false");
+
+
+/************************************************************************************/
+/*               View space partition BSP tree related options                      */
+/************************************************************************************/
+
+
 	RegisterOption("VspBspTree.Termination.minPolygons",
-				   optInt,
-				   "vsp_bsp_term_min_polygons=",
-				   "5");
+					optInt,
+					"vsp_bsp_term_min_polygons=",
+					"5");
 
 	RegisterOption("VspBspTree.Termination.minPvs",
-				   optInt,
-				   "vsp_bsp_term_min_pvs=",
-				   "20");
+					optInt,
+					"vsp_bsp_term_min_pvs=",
+					"20");
 	RegisterOption("VspBspTree.Termination.minArea",
-				   optFloat,
-				   "vsp_bsp_term_min_area=",
-				   "0.001");
+					optFloat,
+					"vsp_bsp_term_min_area=",
+					"0.001");
 
 	RegisterOption("VspBspTree.Termination.maxRayContribution",
-				   optFloat,
-				   "vsp_bsp_term_ray_contribution=",
-				   "0.005");
+					optFloat,
+					"vsp_bsp_term_ray_contribution=",
+					"0.005");
 
 	RegisterOption("VspBspTree.Termination.minAccRayLenght",
-				   optFloat,
-				   "vsp_bsp_term_min_acc_ray_length=",
-				   "50");
+					optFloat,
+					"vsp_bsp_term_min_acc_ray_length=",
+					"50");
 
 	RegisterOption("VspBspTree.Termination.minRays",
-				   optInt,
-				   "vsp_bsp_term_min_rays=",
-				   "-1");
+					optInt,
+					"vsp_bsp_term_min_rays=",
+					"-1");
 
 	RegisterOption("VspBspTree.Termination.ct_div_ci",
-				   optFloat,
-				   "vsp_bsp_term_ct_div_ci=",
-				   "0.0");
+					optFloat,
+					"vsp_bsp_term_ct_div_ci=",
+					"0.0");
 
 	RegisterOption("VspBspTree.Termination.maxDepth",
-				   optInt,
-				   "vsp_bsp_term_max_depth=",
-				   "100");
+					optInt,
+					"vsp_bsp_term_max_depth=",
+					"100");
 
 	RegisterOption("VspBspTree.Termination.AxisAligned.maxCostRatio",
@@ -1725,46 +1733,56 @@
 
 	RegisterOption("VspBspTree.Termination.missTolerance",
-				   optInt,
-				   "vsp_bsp_term_miss_tolerance=",
-				   "4");
+					optInt,
+					"vsp_bsp_term_miss_tolerance=",
+					"4");
 	RegisterOption("VspBspTree.splitPlaneStrategy",
-				   optString,
-				   "vsp_bsp_split_method=",
-				   "leastSplits");
+					optString,
+					"vsp_bsp_split_method=",
+					"leastSplits");
 
 	RegisterOption("VspBspTree.maxPolyCandidates",
-				   optInt,
-				   "vsp_bsp_max_poly_candidates=",
-				   "20");
+					optInt,
+					"vsp_bsp_max_poly_candidates=",
+					"20");
 	RegisterOption("VspBspTree.maxRayCandidates",
-				   optInt,
-				   "vsp_bsp_max_plane_candidates=",
-				   "20");
+					optInt,
+					"vsp_bsp_max_plane_candidates=",
+					"20");
 
 	RegisterOption("VspBspTree.maxTests",
-				   optInt,
-				   "vsp_bsp_max_tests=",
-				   "5000");
+					optInt,
+					"vsp_bsp_max_tests=",
+					"5000");
 
 	RegisterOption("VspBspTree.Construction.samples",
-				   optInt,
-				   "bsp_construction_samples=",
-				   "100000");
+					optInt,
+					"bsp_construction_samples=",
+					"100000");
 
 	RegisterOption("VspBspTree.Construction.epsilon",
-				   optFloat,
-				   "vsp_bsp_construction_side_tolerance=",
-				   "0.002");
+					optFloat,
+					"vsp_bsp_construction_side_tolerance=",
+					"0.002");
 
 	RegisterOption("VspBspTree.Visualization.exportSplits",
-				   optBool,
-				   "vsp_bsp_visualization.export_splits",
-				   "false");
+					optBool,
+					"vsp_bsp_visualization.export_splits",
+					"false");
+
+	RegisterOption("VspBspTree.splitUseOnlyDrivingAxis", 
+					optBool, 
+					"vsp_bsp_splitdriving=", 
+					"false");
+
+	RegisterOption("VspBspTree.Termination.AxisAligned.minRays",
+			optInt,
+			"bsp_term_axis_aligned_min_rays=",
+			"100");
 	
-	RegisterOption("VspBspTree.splitUseOnlyDrivingAxis", 
-				   optBool, 
-				   "vsp_bsp_splitdriving=", 
-				   "false");
-	
+	RegisterOption("VspBspTree.Termination.AxisAligned.maxRayContribution",
+			optFloat,
+			"bsp_term_axis_aligned_min_rays=",
+			"0.1");
+
 	RegisterOption("VspBspTree.Factor.leastRaySplits", optFloat, "-vsp_bsp_factor_least_ray_splits=", "1.0");
 	RegisterOption("VspBspTree.Factor.balancedRays", optFloat, "-vsp_bsp_factor_balanced_rays=", "1.0");
@@ -1785,5 +1803,5 @@
 		"vsp_bsp_term_post_process_max_pvs_size=", 
 		"100");
-	
+
 	RegisterOption("VspBspTree.PostProcess.useRaysForMerge", 
 		optBool, 
@@ -1795,4 +1813,15 @@
 		"vsp_bsp_construction_randomize=", 
 		"false");
+
+	
+	RegisterOption("VspBspTree.maxTotalMemory", 
+		optFloat, 
+		"vsp_bsp_max_total_mem=", 
+		"60.0");
+
+	RegisterOption("VspBspTree.maxStaticMemory", 
+		optFloat, 
+		"vsp_bsp_max_static_mem=", 
+		"8.0");
 	//////////////////////////////////////////////////////////////////////////////////
 }
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 503)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 508)
@@ -2527,4 +2527,14 @@
 
 
+BspNodeGeometry::BspNodeGeometry(const BspNodeGeometry &rhs)
+{
+	PolygonContainer::const_iterator it, it_end = rhs.mPolys.end();
+	for (it = rhs.mPolys.begin(); it != it_end; ++ it)
+	{
+		Polygon3 *poly = *it;
+		mPolys.push_back(new Polygon3(*poly));
+	}
+}
+
 BspNodeGeometry::~BspNodeGeometry()
 {
@@ -2542,23 +2552,8 @@
 {
 	PolygonContainer::const_iterator it, it_end = mPolys.end();
-	int vcount = 0;
-
+	
 	for (it = mPolys.begin(); it != mPolys.end(); ++ it)
 	{
-		Polygon3 *poly = *it;
-		
-		vector<Triangle3> triangles;
-		poly->Triangulate(triangles);
-		vector<Triangle3>::const_iterator tit, tit_end = triangles.end();
-	
-		for (tit = triangles.begin(); tit != tit_end; ++ tit)
-		{
-			mesh.mVertices.push_back((*tit).mVertices[0]);
-			mesh.mVertices.push_back((*tit).mVertices[1]);
-			mesh.mVertices.push_back((*tit).mVertices[2]);
-
-			Face *face = new Face(vcount ++, vcount ++, vcount ++);
-			mesh.AddFace(face);
-		}
+		(*it)->AddToMesh(mesh);
 	}
 }
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp	(revision 496)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp	(revision 508)
@@ -59,9 +59,8 @@
 Preprocessor::LoadScene(const string filename)
 {
-  // use leaf nodes of the original spatial hiearrchy as occludees
-
-  mSceneGraph = new SceneGraph;
+	// use leaf nodes of the original spatial hiearrchy as occludees
+	mSceneGraph = new SceneGraph;
   
-  Parser *parser;
+	Parser *parser;
 	vector<string> filenames;
 	int files = SplitFilenames(filename, filenames);
@@ -176,4 +175,5 @@
 }
 
+
 bool Preprocessor::PrepareViewCells()
 {
@@ -257,5 +257,5 @@
 		environment->GetStringValue("ViewCells.filename", buff);
 		string vcFilename(buff);
-		mViewCellsManager->LoadViewCells(vcFilename);
+		mViewCellsManager->LoadViewCells(vcFilename, &mObjects);
 	}
 
@@ -364,5 +364,6 @@
 }
 
-bool Preprocessor::WriteSamples(const VssRayContainer &samples) const
+
+bool Preprocessor::ExportSamples(const VssRayContainer &samples) const
 {
 	char fileName[100];
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.cpp	(revision 504)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.cpp	(revision 508)
@@ -580,5 +580,5 @@
 	cout << "#totalRayStackSize=" << (int)mVssRays.size() << endl <<flush;
 	
-	rssSamples += mVssRays.size();
+	rssSamples += (int)mVssRays.size();
 	
 	
@@ -592,5 +592,5 @@
 	  {
 		cout << "Writing samples to file ... ";
-		WriteSamples(mVssRays);
+		ExportSamples(mVssRays);
 		cout << "finished\n" << endl;
 	  }
@@ -731,5 +731,5 @@
 	  VssRayContainer contributingRays;
 	  vssRays.GetContributingRays(contributingRays, mPass);
-	  mStats<<"#NUM_CONTRIBUTING_RAYS\n"<<contributingRays.size()<<endl;
+	  mStats<<"#NUM_CONTRIBUTING_RAYS\n"<<(int)contributingRays.size()<<endl;
 	  sprintf(filename, "rss-crays-%04d.x3d", rssPass);
 	  ExportRays(filename, contributingRays, mExportNumRays);
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp	(revision 501)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp	(revision 508)
@@ -29,4 +29,5 @@
   environment->GetBoolValue("VssPreprocessor.storeInitialSamples", mStoreInitialSamples);
   environment->GetBoolValue("VssPreprocessor.useViewSpaceBox", mUseViewSpaceBox);
+  useViewspacePlane = mUseViewSpaceBox; //hack
 
   mStats.open("stats.log");
@@ -473,5 +474,5 @@
   {
 	  cout << "Writing " << (int)mVssRays.size() << " samples to file ... ";
-	  WriteSamples(mVssRays);
+	  ExportSamples(mVssRays);
 	  cout << "finished\n" << endl;
 
